import java.net.ServerSocket;
import java.net.Socket;

public abstract class TCPListener extends Listener {
  abstract void connected(Socket socket);

  void runServer() {
    Thread me = Thread.currentThread();
    try { _serverSocket=new ServerSocket(_port); }
    catch (Exception ex) {
      System.out.println("port "+_port+": "+ex);
      return;
    }

    while (me == _listenerThread) {
      try {
        _socket=_serverSocket.accept();
        connected(_socket);
      } catch (Exception ex) { }
    }
  }

  void runConnect() {
    Thread me = Thread.currentThread();
    while (me==_listenerThread) {
      try {
        _socket=new Socket(_host,_port);
        connected(_socket);
        Thread.sleep(500);
      } catch (Exception ex) { }
    }
  }

  public void close() {
    _listenerThread=null;
    try { _socket.close(); } catch (Exception ex) { }
    if (_isServer)
      try { _serverSocket.close(); } catch (Exception ex) { }
  }

  public TCPListener() { super(); }
  public TCPListener(int port) { super(port); }
  public TCPListener(String host, int port) { super(host,port); }

  Socket _socket;
  ServerSocket _serverSocket;
}
